<?php
/*
Plugin Name: my-smtp-contact
Description: Contact form with a captcha and the ability to send emails via SMTP (smtp tested: @yandex.ru @mail.ru @gmail.com)
Version: 1.0.5 / jul 2019
Author: NetExplorer
Email: netexplorer@yandex.ru
Author URI: http://netexplorer.h1n.ru

This plugin will help you to set up a contact form with captcha and checkbox. 
Plugin can be used SMTP (Simple Mail Transfer Protocol) to send mail.

How to install a contact form?

Unzip and place file in the plugin folder of GetSimple. Then activate the plugin. 
Add this line of code to the template where you would like to display the contact form. 
For example, place this code in the side column of the template. 
Or create a component and paste this code into it.

<?php if ( function_exists('MSC_Mail') && function_exists('MSC_Form') ) { MSC_Mail(); MSC_Form(); } ?>

Standard PHP mail sending is enabled by default.

SMTP tested with @yandex.ru, @mail.ru, @gmail.com ...

The plugin can be translated into other languages. See /lang/en.php, ru.php ... 
Make your translation and upload the "xx.php" file to the directory - /lang/ - then select your language file in the plugin settings.
*/

// Get correct id for plugin
$m_smtp_c_thisfile = basename(__FILE__, ".php");

// Load configuration
require($m_smtp_c_thisfile.'/cfg.php');

// Load language
require($m_smtp_c_thisfile.'/lang/'.$m_smtp_c_language.'.php');

// Register plugin
register_plugin(
    $m_smtp_c_thisfile,    // ID of plugin, should be filename minus php
    $m_smtp_c_plugin_name,    // Title of plugin
    '1.0.5',    // Version of plugin
    'NetExplorer',    // Author of plugin
    'http://netexplorer.h1n.ru',    // Author URL
    $m_smtp_c_small_description,    // Plugin Description
    'plugins',    // Page type of plugin
    'm_smtp_c_options'    // Function that displays content
);

// Creates a menu option on the Admin/Theme sidebar
add_action('plugins-sidebar', 'createSideMenu', array($m_smtp_c_thisfile, $m_smtp_c_plugin_name));

// Show options in plugin page
function m_smtp_c_options() {
	global $m_smtp_c_thisfile, $m_smtp_c_language;
	
	// Load language
	require($m_smtp_c_thisfile.'/lang/'.$m_smtp_c_language.'.php');
	
	// Please do not remove the donation button
	echo $m_smtp_c_description . "
<form action='https://www.paypal.com/cgi-bin/webscr' method='post' target='_blank'>
<input type='hidden' name='cmd' value='_donations'>
<input type='hidden' name='business' value='netexplorer@yandex.ru'>
<input type='hidden' name='currency_code' value='USD'>
<input type='submit' border='0' name='submit' class='button' value='$m_smtp_c_admin_donate' title='Donate with PayPal button' alt='Donate with PayPal button'>
</form>";

	// Load plugin settings
	require($m_smtp_c_thisfile.'/admin.php');
}

if (isset($_POST['m_smtp_c_submitted'])) {
    $m_smtp_c_name_value = $_POST['m_smtp_c_name_value'];
    $m_smtp_c_email_value = $_POST['m_smtp_c_email_value'];
    $m_smtp_c_message_value = $_POST['m_smtp_c_message_value'];
}

// Standard php mail
function m_smtp_c_STANDART($to, $theme, $messege, $from = '') {
	$subject = '=?utf-8?B?'.trim(base64_encode($theme)).'?=';
	$headers = '';
	if ($from != '') { $headers .= "From: $from\r\n"; }
		$headers .= "MIME-Version: 1.0\r\n";
		$headers .= "Content-Transfer-Encoding: 8bit\r\n";
		$headers .= "Content-Type: text/plain; charset=\"utf-8\"\r\n"; // text/html
		$headers .= "X-Mailer: PHP v.".phpversion();
	return mail($to, $subject, $messege, $headers); 
}

// Send Mail
function MSC_Mail() {
    global $m_smtp_c_success_msg, $m_smtp_c_captcha_name, $m_smtp_c_digital_captcha, $m_smtp_c_StopSpam_error, $m_smtp_c_agree_checkbox, $m_smtp_c_email_to, $m_smtp_c_name_value, $m_smtp_c_email_value, $m_smtp_c_subject, $m_smtp_c_message_value;
	global $m_smtp_c_thisfile, $m_smtp_c_Name, $m_smtp_c_Email, $m_smtp_c_Message, $m_smtp_c_smtp_or_standart, $m_smtp_c_email_from, $m_smtp_c_email_from_password, $m_smtp_c_email_from_ssl, $m_smtp_c_email_from_port, $m_smtp_c_digitSalt, $m_smtp_c_NameEmailMessage_error, $m_smtp_c_Email_error, $m_smtp_c_Captcha_error, $m_smtp_c_Settings_error, $m_smtp_c_Success;
	
    $error = 0;
    $m_smtp_c_success_msg = '';
	
    if (isset($_POST['m_smtp_c_submitted'])) {
     	$m_smtp_c_name_value = htmlspecialchars($_POST['m_smtp_c_name_value']);
        $m_smtp_c_email_value = htmlspecialchars($_POST['m_smtp_c_email_value']);
        $m_smtp_c_message_value = htmlspecialchars($_POST['m_smtp_c_message_value']);
		
		if ( ($m_smtp_c_digital_captcha != 'on' && $m_smtp_c_digital_captcha != 'off') || ($m_smtp_c_agree_checkbox != 'on') && ($m_smtp_c_agree_checkbox != 'off') ) {
		$m_smtp_c_success_msg .= $m_smtp_c_Settings_error;
		$error = 1;
		}
		if (empty($m_smtp_c_name_value) || empty($m_smtp_c_email_value) || empty($m_smtp_c_message_value)) {
            $m_smtp_c_success_msg .= $m_smtp_c_NameEmailMessage_error;
            $error = 1;
        }
        if (!preg_match("/^[^@]+@[^@.]+\.[^@]+$/", $m_smtp_c_email_value)) { 
            $m_smtp_c_success_msg .= $m_smtp_c_Email_error;
            $error = 1;
        }
		if ($m_smtp_c_digital_captcha == 'on') { 
		if (md5($_POST['m_smtp_c_captcha_name'] . $m_smtp_c_digitSalt) != $_COOKIE['MSC_digit']) {
            $m_smtp_c_success_msg .= $m_smtp_c_Captcha_error;
            $error = 1;  		
        }}
		if ($_POST['email'] != '') {
			$m_smtp_c_success_msg .= $m_smtp_c_StopSpam_error;
            $error = 1;
		}
		
        if ($error != 1) {
			
			$m_smtp_c_success_msg = $m_smtp_c_Success;
			
			$sit = htmlspecialchars($_SERVER['HTTP_HOST']);
			$message = "$m_smtp_c_Name: ".$m_smtp_c_name_value;
            $message = $message."\n". "$m_smtp_c_Email: ".$m_smtp_c_email_value;
            $message = $message."\n". "$m_smtp_c_Message: ".$m_smtp_c_message_value;
			
			if ($m_smtp_c_smtp_or_standart == 'smtp') { // SMTP
				require($m_smtp_c_thisfile.'/SendMailSmtpClass.php');
				$mailSMTP = new SendMailSmtpClass($m_smtp_c_email_from, $m_smtp_c_email_from_password, $m_smtp_c_email_from_ssl, $m_smtp_c_email_from_port, "UTF-8");
				$from = array(
				"My-robot", 
				"$m_smtp_c_email_from"
				);
				$mailSMTP->send($m_smtp_c_email_to, $m_smtp_c_subject, $message, $from);
			} 
			elseif ($m_smtp_c_smtp_or_standart == 'standart') { // standard php
				$from = "My-robot <robot@$sit>";
				m_smtp_c_STANDART($m_smtp_c_email_to, $m_smtp_c_subject, $message, $from);
			} 
			else { 
				$m_smtp_c_success_msg = $m_smtp_c_Settings_error; 
			}
			
			$_POST = array();
            $m_smtp_c_email_value = $m_smtp_c_name_value = $m_smtp_c_message_value = '';
        }
		
    } else {
        $m_smtp_c_success_msg = '';
    }
}

// Display Form
function MSC_Form() {
    global $m_smtp_c_success_msg, $m_smtp_c_captcha_name, $m_smtp_c_agree_checkbox, $m_smtp_c_digital_captcha, $m_smtp_c_email_value, $m_smtp_c_name_value, $m_smtp_c_message_value;
	global $m_smtp_c_thisfile, $m_smtp_c_Name, $m_smtp_c_Email, $m_smtp_c_Message, $m_smtp_c_Captcha, $m_smtp_c_agree, $m_smtp_c_agree_error, $m_smtp_c_Submit;

echo '
<div class="m_smtp_c">';

// Form
if ($m_smtp_c_agree_checkbox == 'on') { // with checkbox
echo '
<form name="m_smtp_c_form" method="post" onsubmit="if(document.getElementById(\'m_smtp_c_agree\').checked) { this.submit(); } else { alert(\''.$m_smtp_c_agree_error.'\'); return false; }">';
}
else { // without checkbox
echo '
<form name="m_smtp_c_form" method="post">';
}

// Fields
echo '
<p>
'.$m_smtp_c_Name.'<br>
<input size="26" type="text" value="'.$m_smtp_c_name_value.'" name="m_smtp_c_name_value" maxlength="200" required>
</p>
<p>
'.$m_smtp_c_Email.'<br>
<input size="26" type="email" value="'.$m_smtp_c_email_value.'" name="m_smtp_c_email_value" maxlength="200" required>
</p>
<p>
'.$m_smtp_c_Message.'<br>
<textarea rows="5" cols="50" name="m_smtp_c_message_value" maxlength="5000" required>'.$m_smtp_c_message_value.'</textarea>
</p>';

// Captcha
if ($m_smtp_c_digital_captcha == 'on') {
echo '
<p>
<a href="#" onclick="document.getElementById(\'my_captcha\').src = \'/plugins/'.$m_smtp_c_thisfile.'/captcha.php?\' + Math.random(); document.getElementById(\'my_captcha_code_input\').value = \'\'; return false;">
<img id="my_captcha" src="/plugins/'.$m_smtp_c_thisfile.'/captcha.php?rand='.rand(0, 99999).'" alt="captcha"></a>
<br>
'.$m_smtp_c_Captcha.'
<br>
<input id="my_captcha_code_input" type="text" name="m_smtp_c_captcha_name" value="" size="6" maxlength="5" onkeyup="this.value = this.value.replace(/[^\d]+/g, \'\');" pattern="\d{5}" required>
</p>';
}

// Checkbox
if ($m_smtp_c_agree_checkbox == 'on') {
echo '
<p>
<input style="vertical-align: middle;" type="checkbox" name="m_smtp_c_agree" value="ok" id="m_smtp_c_agree">
<label for="m_smtp_c_agree">'.$m_smtp_c_agree.'</label>
</p>';
}

// Simple spam protect
echo '
<p style="display:none!important;">
<input id="m_smtp_c_submitted" type="hidden" value="true" name="m_smtp_c_submitted">
<input size="6" type="text" value="" name="email" placeholder="do not fill" maxlength="200">
</p>';

// Save button
echo '
<p>
<input type="submit" name="" value="'.$m_smtp_c_Submit.'">
</p>

</form>

</div>';

// Message
echo $m_smtp_c_success_msg;

}

// You can run the plugin in the Theme also with this function
function MSC_Show() {
    global $m_smtp_c_thisfile, $m_smtp_c_plugin_name;
    add_action('content-top', 'MSC_Mail', array($m_smtp_c_thisfile, $m_smtp_c_plugin_name));
    add_action('content-bottom', 'MSC_Form', array($m_smtp_c_thisfile, $m_smtp_c_plugin_name));
}

?>